unit Main;

interface

uses
  Windows, Messages, ShellAPI, SysUtils, Classes, Graphics, Controls, Forms,
  DBCtrls, StdCtrls, ExtCtrls, Grids, DBGrids, ComCtrls, DataMod;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    SB: TStatusBar;
    DBGrid1: TDBGrid;
    Splitter1: TSplitter;
    DBMemo1: TDBMemo;
    ComboBox1: TComboBox;
    Label1: TLabel;
    DBNavigator1: TDBNavigator;
    procedure FormShow(Sender: TObject);
    procedure ComboBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    CurPos : Longint;
    P      : TProgressBar;
    Compressing: Boolean;
    procedure WMDROPFILES(var Message: TMessage); message WM_DROPFILES;
    procedure Progress(Sender: TObject; Msg: String; Position: Integer);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
  EQ_Abort, Tools;

procedure TForm1.FormCreate(Sender: TObject);
begin
  P := TProgressBar.Create(Self);
  P.Parent := SB;
  P.SetBounds(1, 2, SB.Panels[0].Width-2, SB.Height-2);
  P.Visible := False;
  DM.tblCompressedNotes.OnProgress := Progress;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  DragAcceptFiles(Handle, True);
  ComboBox1.ItemIndex := 0;
  DM.CurTableName := ComboBox1.Items[0];
end;

procedure TForm1.ComboBox1Click(Sender: TObject);
begin
  DM.CurTableName := ComboBox1.Items[ComboBox1.ItemIndex];
end;

procedure TForm1.WMDROPFILES(var Message: TMessage);
var
  FilesDropped  : TStringList;
  I             : Integer;
begin
  P.Visible := True;
  DM.DataSource.DataSet.DisableControls;
  try
    Screen.Cursor := crHourGlass;
    try
      FilesDropped := GetDropppedFiles(Message.wParam);
      try
        for I := 0 to FilesDropped.Count - 1 do
        begin
          CurPos := 0;
          Compressing := True;
          SB.Panels[1].Text := FilesDropped[I];
          DM.InsertFile(FilesDropped[I]);
        end;
      finally
        FilesDropped.Free;
      end;
    finally
      Screen.Cursor := crDefault;
    end;
  finally
    DM.DataSource.DataSet.EnableControls;
    SB.Panels[1].Text := '';
    P.Visible := False;
  end;
end;

procedure TForm1.Progress(Sender: TObject; Msg: String; Position: Integer);
begin
  if Msg = 'size' then
  begin
    P.Max := Position;
    P.Position := 0;
    if not P.Visible then
      P.Visible := True;
  end else

  if Msg = 'completed' then
    P.Visible := False
  else

  if Compressing then
    if Msg = 'read' then
    begin
      Inc(CurPos, Position);
      P.Position := CurPos;
    end
    else
  else
    if Msg = 'write' then
    begin
      Inc(CurPos, Position);
      P.Position := P.Position + Position;
    end;
  AbortProc;
end;

end.

